=== debian/changelog ===
libv8 (3.5.10.24-4) unstable; urgency=low

  * v8_use_arm_eabi_hardfloat must be passed in GYPFLAGS,
    this should fix armhf build.
  * Ubuntu vendor needs different armel architecture settings.

 -- Jérémy Lal <kapouer@melix.org>  Mon, 05 Dec 2011 11:36:38 +0100

libv8 (3.5.10.24-3) unstable; urgency=low

  * Fix build failures for arm:
    + arm_neon=0 for armhf
    + vfp3=off for armel
    Closes: bug#650548

 -- Jérémy Lal <kapouer@melix.org>  Fri, 02 Dec 2011 10:17:48 +0100

libv8 (3.5.10.24-2) unstable; urgency=low

  * Set -Wno-unused-but-set-variable, i386 build fail otherwise.
    Closes: bug#650547
  * Remove mipsel from architectures. Will be re-enabled when
    upstream really supports it.
    Closes: bug#650549
  * Disable default arm flags (debian/0014_disable_armv7_defaults.patch) and
    set them properly for armel and armhf, using GYPFLAGS variable in
    debian/rules. Closes: bug#650548
  * Remove 0009_unaligned_access_armel.patch, never proved it was needed.
  * Remove -fvisibility=hidden flag, applied upstream.
  * CCFLAGS are ignored by the build system, use CXXFLAGS instead.

 -- Jérémy Lal <kapouer@melix.org>  Thu, 01 Dec 2011 14:31:59 +0100

libv8 (3.5.10.24-1) unstable; urgency=low

  * New upstream release.

  [ Jérémy Lal ]
  * Build using gyp (instead of deprecated scons build):
    + removed scons patches
    + added gyp patches to achieve the same result.
  * Remove mipsel architecture, not yet supported upstream.
  * Tests are run using d8 instead of shell.
  * Allow parallel builds.
  * Update watch file: Track 3.5.x releases.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 26 Nov 2011 00:34:40 +0700
