=== debian/control ===
Source: libv8
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Jérémy Lal <kapouer@melix.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends: cdbs (>= 0.4.72~),
 devscripts,
 debhelper,
 dh-buildinfo, libicu-dev, gyp
Standards-Version: 3.9.2
Section: libs
Homepage: http://code.google.com/p/v8/
DM-Upload-Allowed: yes
Vcs-Browser: http://git.debian.org/?p=collab-maint/libv8.git
Vcs-Git: git://git.debian.org/git/collab-maint/libv8.git

Package: libv8-dev
Section: libdevel
Architecture: i386 amd64 armel armhf
Depends: libv8-3.5.10.24 (= ${binary:Version}), ${misc:Depends}
Description: v8 JavaScript engine - development files
 V8 is a high performance JavaScript engine written in C++.  It is used
 in the web browser Chromium.
 .
 Install this package if you wish to develop your own programs using the
 v8 JavaScript engine.

Package: libv8-3.5.10.24
Architecture: i386 amd64 armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: v8 JavaScript engine - runtime library
 V8 is a high performance JavaScript engine written in C++.  It is used
 in the web browser Chromium.
 .
 This package includes the dynamic library against which you can link
 your program.

Package: libv8-dbg
Priority: extra
Section: debug
Architecture: i386 amd64 armel armhf
Depends: libv8-3.5.10.24 (= ${binary:Version}), ${misc:Depends}
Description: v8 JavaScript engine - debugging symbols
 V8 is a high performance JavaScript engine written in C++.  It is used
 in the web browser Chromium.
 .
 This package provides the debugging symbols for the library.
