## libv8 3.6.6.14

=== debian/changelog ===
libv8 (3.6.6.14-2) unstable; urgency=low

  * Land hash collision fix for V8 3.6. Closes: bug#653962.
    This fixes CVE-2011-5037.
  * snapshot=off, because hash is randomized by a secret key that is
    otherwise readable in the snapshot.

 -- Jérémy Lal <kapouer@melix.org>  Sat, 07 Jan 2012 22:29:06 +0100

libv8 (3.6.6.14-1) unstable; urgency=low

  [ Jérémy Lal ]
  * Upstream update.
  * Refresh patches. Remove unused 0009_unaligned_access_armel.patch.
  * Add samples/*.cc, samples/*.js and provide usable samples.gyp
    to libv8-dev examples. Closes: bug#612362.
  * Update watch file: Track 3.6.x releases.

  [ Jonas Smedegaard ]
  * Newline-separate package relations in control file.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 03 Jan 2012 22:00:29 +0100
