=== debian/rules ===
--- 
+++ 
@@ -67,7 +67,7 @@
 export GYPFLAGS
 export CXXFLAGS
 
-DEB_MAKE_EXTRA_ARGS += library=shared soname_version=$(SONAME) OS=$(v8os) V=1 
+DEB_MAKE_EXTRA_ARGS += library=shared snapshot=off soname_version=$(SONAME) OS=$(v8os) V=1 
 DEB_MAKE_CLEAN_TARGET = clean
 DEB_MAKE_BUILD_TARGET = $(v8arch).release
