=== SConstruct ===
--- 
+++ 
@@ -129,6 +129,10 @@
       'LIBPATH' : ['/usr/local/lib'],
       'CCFLAGS':      ['-ansi'],
     },
+    'os:netbsd': {
+      'CPPPATH' : ['/usr/pkg/include'],
+      'LIBPATH' : ['/usr/pkg/lib'],
+    },
     'os:win32': {
       'CCFLAGS':      ['-DWIN32'],
       'CXXFLAGS':     ['-DWIN32'],
@@ -364,6 +368,9 @@
     'os:win32': {
       'LIBS': ['winmm', 'ws2_32'],
     },
+    'os:netbsd': {
+      'LIBS': ['execinfo', 'pthread']
+    },
     'compress_startup_data:bz2': {
       'os:linux': {
         'LIBS': ['bz2']
@@ -413,9 +420,3 @@
       'CCFLAGS':      ['-Wno-unused-but-set-variable'],
     },
     'os:macos': {
-      'LIBS':         ['pthread'],
-    },
-    'os:freebsd': {
-      'LIBS':         ['execinfo', 'pthread']
-    },
-    'os:solaris': {
