=== debian/changelog ===
libv8 (3.7.12.22-3) unstable; urgency=low

  * Fix mipsel build, allow test debug-step-3 to fail (non-crucial)

 -- Jérémy Lal <kapouer@melix.org>  Mon, 20 Feb 2012 14:08:17 +0100

libv8 (3.7.12.22-2) unstable; urgency=low

  * Adjust tests timeout from 120 to 180 seconds because build server
    can be busy sometimes.
  * Fix failing "make check" for mips arch in:
    + debian/patches/0015_enable_mips_tests.patch

 -- Jérémy Lal <kapouer@melix.org>  Sun, 19 Feb 2012 18:18:57 +0100

libv8 (3.7.12.22-1) unstable; urgency=low

  * New upstream release.

  [ Jérémy Lal ]
  * Enable mipsel arch.
  * Refresh patches. Remove unnecessary patches:
    + 0010_fix_arm_bug.patch (applied upstream).
    + 0012_make_check_testsuites.patch (uses TESTFLAGS, not TESTSUITES).
    + 0013_enable_soname.patch (applied upstream).
    + 0015_hash-collision-fix-v8-3.6.patch (applied upstream.
  * Fix tabs and whitespaces in debian/samples.gyp.
  * Stop setting v8_can_use_unaligned_accesses=false during build: works
    without it - and it even may be triggering an alignment bug.

  [ Jonas Smedegaard ]
  * Update copyright file:
    + Extend (and shorten) some copyright years.
    + Fix paths of a few files.
    + Rewrap comments at 72 chars.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 13 Feb 2012 20:18:39 +0100
