=== debian/control ===
--- 
+++ 
@@ -18,9 +18,8 @@
 
 Package: libv8-dev
 Section: libdevel
-Architecture: i386 amd64 armel armhf
-Depends: libv8-3.6.6.14 (= ${binary:Version}),
- ${misc:Depends}
+Architecture: i386 amd64 armel armhf mipsel
+Depends: libv8-3.7.12.22 (= ${binary:Version}), ${misc:Depends}
 Description: v8 JavaScript engine - development files
  V8 is a high performance JavaScript engine written in C++.  It is used
  in the web browser Chromium.
@@ -28,10 +27,9 @@
  Install this package if you wish to develop your own programs using the
  v8 JavaScript engine.
 
-Package: libv8-3.6.6.14
-Architecture: i386 amd64 armel armhf
-Depends: ${shlibs:Depends},
- ${misc:Depends}
+Package: libv8-3.7.12.22
+Architecture: i386 amd64 armel armhf mipsel
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: v8 JavaScript engine - runtime library
  V8 is a high performance JavaScript engine written in C++.  It is used
  in the web browser Chromium.
@@ -42,9 +40,8 @@
 Package: libv8-dbg
 Priority: extra
 Section: debug
-Architecture: i386 amd64 armel armhf
-Depends: libv8-3.6.6.14 (= ${binary:Version}),
- ${misc:Depends}
+Architecture: i386 amd64 armel armhf mipsel
+Depends: libv8-3.7.12.22 (= ${binary:Version}), ${misc:Depends}
 Description: v8 JavaScript engine - debugging symbols
  V8 is a high performance JavaScript engine written in C++.  It is used
  in the web browser Chromium.
