=== debian/rules ===
--- 
+++ 
@@ -60,7 +60,7 @@
 # http://code.google.com/p/v8/issues/detail?id=590
 CXXFLAGS += -mno-thumb-interwork
 # disable armv7, use softfloat
-GYPFLAGS += -Darmv7=0 -Dv8_can_use_unaligned_accesses=false -Dv8_use_arm_eabi_hardfloat=false
+GYPFLAGS += -Darmv7=0 -Dv8_use_arm_eabi_hardfloat=false
 endif
 endif
 
@@ -78,8 +78,8 @@
 #  * run only javascript tests, cctests are for development purposes
 DEB_MAKE_CHECK_TARGET = $(v8arch).release.check \
 	LD_PRELOAD=$(v8out) \
-	TESTSUITES="mjsunit message preparser" \
-	TESTJOBS="$(DEB_MAKE_PARALLEL) --timeout=120" \
+	TESTFLAGS="mjsunit message preparser" \
+	TESTJOBS="$(DEB_MAKE_PARALLEL) --timeout=180" \
 	$(if $(shell dpkg-parsechangelog | grep -Fx 'Distribution: experimental'),|| true)
